'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _connect = require('react-redux/lib/components/connect');

var _connect2 = _interopRequireDefault(_connect);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _memoize = require('lodash/memoize');

var _memoize2 = _interopRequireDefault(_memoize);

var _sequence = require('../utils/sequence');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createControlProps = (0, _memoize2.default)(function (props) {
  var model = props.model;
  var modelValue = props.modelValue;
  var control = props.control;
  var mapProps = props.mapProps;


  if (!mapProps) {
    return false;
  }

  return mapProps(_extends({
    model: model,
    modelValue: modelValue
  }, control.props, (0, _sequence.sequenceEventActions)(props)));
});

function selector(state, props) {
  var controlProps = createControlProps(props);

  var model = props.model;

  var modelString = typeof model === 'function' ? model(state) : model;

  return _extends({
    model: modelString,
    modelValue: (0, _get3.default)(state, modelString)
  }, controlProps);
}

var Control = function (_Component) {
  _inherits(Control, _Component);

  function Control(props) {
    _classCallCheck(this, Control);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Control).call(this, props));

    _this.handleKeyPress = _this.handleKeyPress.bind(_this);
    return _this;
  }

  _createClass(Control, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props;
      var onLoad = _props.onLoad;
      var modelValue = _props.modelValue;


      if (onLoad) {
        onLoad(modelValue);
      }
    }
  }, {
    key: 'handleKeyPress',
    value: function handleKeyPress(event) {
      var onSubmit = this.props.onSubmit;


      if (onSubmit && event.key === 'Enter') {
        onSubmit(event);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var control = this.props.control;


      return (0, _react.cloneElement)(control, _extends({}, control.props, this.props, {
        onKeyPress: this.handleKeyPress
      }));
    }
  }]);

  return Control;
}(_react.Component);

Control.propTypes = {
  control: _react.PropTypes.any,
  onLoad: _react.PropTypes.func,
  onSubmit: _react.PropTypes.func,
  modelValue: _react.PropTypes.any,
  mapProps: _react.PropTypes.func
};

exports.default = (0, _connect2.default)(selector)(Control);